%global realname rebar3
%global otp_app_name rebar

# Technically we're noarch, but our install path is not.
%global debug_package %{nil}

# Bootstrapping
%global bootstrap 0

Name:     erlang-%{realname}
Version:  3.9.0
%define subrel 1
Release:  %mkrel 1
Summary:  Tool for working with Erlang projects
Group:    Development/Other
License:  ASL 2.0 and MIT
URL:      https://github.com/erlang/rebar3
Source0:  %{url}/archive/%{version}.tar.gz#/%{realname}-%{version}.tar.gz
# Escript used to launch rebar3
Patch0:   add-rebar3-escript.patch
# To fix CVE-2020-13802 (mga#25511)
# https://github.com/erlang/rebar3/pull/2302
Patch1:   0001-Escape-more-characters-for-shell-stuff.patch
%if 0%{?bootstrap}
Source1:  https://github.com/erlang/rebar3/releases/download/%{version}/rebar3#/%{realname}-%{version}
%else
BuildRequires:  erlang-rebar3
%endif
BuildRequires:  erlang-erts
BuildRequires:  erlang-erlware_commons
BuildRequires:  erlang-ssl_verify_fun
BuildRequires:  erlang-certifi
BuildRequires:  erlang-providers
BuildRequires:  erlang-getopt
BuildRequires:  erlang-bbmustache
BuildRequires:  erlang-relx
BuildRequires:  erlang-cf
BuildRequires:  erlang-cth_readable
BuildRequires:  erlang-eunit_formatters
BuildRequires:	erlang-hex_core
Requires:  erlang-erts
Requires:  erlang-erlware_commons
Requires:  erlang-ssl_verify_fun
Requires:  erlang-certifi
Requires:  erlang-providers
Requires:  erlang-getopt
Requires:  erlang-bbmustache
Requires:  erlang-relx
Requires:  erlang-cf
Requires:  erlang-cth_readable
Requires:  erlang-eunit_formatters
Requires:  erlang-hex_core
Provides:  rebar3 = %{version}-%{release}

%description
Rebar3 is an Erlang tool that makes it easy to create, develop, and release
Erlang libraries, applications, and systems in a repeatable manner.

%prep
%setup -q -n %{realname}-%{version}
%autopatch -p1

%if 0%{?bootstrap}
install -Dpm755 %{SOURCE1} precompiled/%{realname}
%endif

%build
ebin_paths=$(perl -e 'print join(":", grep { !/rebar/} glob("%{_libdir}/erlang/lib/*/ebin"))')
%if 0%{?bootstrap}
./precompiled/%{realname} bare compile --paths $ebin_paths --separator :
%else
%{_bindir}/%{realname} bare compile --paths $ebin_paths --separator :
%endif

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin/
mkdir -p %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/priv/
mkdir -p %{buildroot}%{_mandir}/man1/
install -p -m755 %{realname} %{buildroot}%{_bindir}/%{realname}
install -p -m644 ebin/*.beam %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin/
install -p -m644 ebin/%{otp_app_name}.app %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin/
install -p -m755 -d priv/* %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/priv/
install -p -m644 manpages/%{realname}.1 %{buildroot}%{_mandir}/man1/

%files
%license LICENSE
%doc README.md
%{_bindir}/%{realname}
%{_libdir}/erlang/lib/%{realname}-%{version}
%{_mandir}/man1/%{realname}.1*


%changelog
* Sun Dec 20 2020 wally <wally> 3.9.0-1.1.mga7
+ Revision: 1661838
- add upstream patch to fix CVE-2020-13802 (mga#27511)

* Sun Feb 17 2019 wally <wally> 3.9.0-1.mga7
+ Revision: 1367913
- non-bootstrap build

* Sun Feb 17 2019 wally <wally> 3.9.0-0.mga7
+ Revision: 1367912
- new version 3.9.0
- bootstrap build

* Tue Nov 20 2018 wally <wally> 3.6.2-1.mga7
+ Revision: 1332468
- imported package erlang-rebar3


* Fri Oct 12 2018 Timothée Floure <fnux@fedoraproject.org> - 3.6.2-1
- Let there be package
